scala.tools.nsc.typechecker.RefChecks.RefCheckTransformer

# varianceValidator

###
Related Doc: package RefCheckTransformer

#### object varianceValidator extends Global.VarianceValidator

Source
  RefChecks.scala

Linear Supertypes
Global.VarianceValidator, Global.Traverser, AnyRef, Any
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. varianceValidator
2. VarianceValidator
3. Traverser
4. AnyRef
5. Any

1. Hide All
2. Show all

Learn more about member selection
Visibility

1. Public
2. All

### Value Members

1. #### final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     AnyRef → Any

2. #### final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types and `null`.

   Equivalent to `x.hashCode` except for boxed numeric types and `null`. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them. For `null` returns a hashcode where `null.hashCode` throws a `NullPointerException`.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any

3. #### final def ==(arg0: Any): Boolean

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   arg0

     the object to compare against this object for equality.

   returns

     `true` if the receiver object is equivalent to the argument; `false` otherwise.

   Definition Classes
     AnyRef → Any

4. #### def apply[T <: Global.Tree](tree: T): T

   Definition Classes
     Traverser

5. #### final def asInstanceOf[T0]: T0

   Cast the receiver object to be of type `T0`.

   Cast the receiver object to be of type `T0`.

   Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

   returns

     the receiver object.

   Definition Classes
     Any
   Exceptions thrown

     `ClassCastException` if the receiver object is not an instance of the erasure of type `T0`.

6. #### def atOwner(owner: Global.Symbol)(traverse: ⇒ Unit): Unit

   Definition Classes
     Traverser

7. #### final def checkForEscape(sym: Global.Symbol, site: Global.Symbol): Unit

   Definition Classes
     VarianceValidator
   Annotations
     @tailrec()

8. #### def clone(): AnyRef

   Create a copy of the receiver object.

   Create a copy of the receiver object.

   The default implementation of the `clone` method is platform dependent.

   returns

     a copy of the receiver object.

   Attributes
     protected[java.lang]
   Definition Classes
     AnyRef
   Annotations
     @throws( ... )
   Note

     not specified by SLS as a member of AnyRef

9. #### var currentOwner: Global.Symbol

   Attributes
     protected[scala]
   Definition Classes
     Traverser

10. #### final def eq(arg0: AnyRef): Boolean

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

    - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
    - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
    - `null.eq(null)` returns `true`.

    When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

    returns

      `true` if the argument is a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

11. #### def equals(arg0: Any): Boolean

    The equality method for reference types.

    The equality method for reference types. Default implementation delegates to `eq`.

    See also `equals` in scala.Any.

    returns

      `true` if the receiver object is equivalent to the argument; `false` otherwise.

    Definition Classes
      AnyRef → Any

12. #### def finalize(): Unit

    Called by the garbage collector on the receiver object when there are no more references to the object.

    Called by the garbage collector on the receiver object when there are no more references to the object.

    The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )
    Note

      not specified by SLS as a member of AnyRef

13. #### final def getClass(): Class[_]

    A representation that corresponds to the dynamic class of the receiver object.

    A representation that corresponds to the dynamic class of the receiver object.

    The nature of the representation is platform dependent.

    returns

      a representation that corresponds to the dynamic class of the receiver object.

    Definition Classes
      AnyRef → Any
    Note

      not specified by SLS as a member of AnyRef

14. #### def hashCode(): Int

    The hashCode method for reference types.

    The hashCode method for reference types. See hashCode in scala.Any.

    returns

      the hash code value for this object.

    Definition Classes
      AnyRef → Any

15. #### final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any

16. #### def isLocalOnly(sym: Global.Symbol): Boolean

    Definition Classes
      VarianceValidator

17. #### def issueVarianceError(base: Global.Symbol, sym: Global.Symbol, required: Variance): Unit

    Definition Classes
      varianceValidator → VarianceValidator

18. #### final def ne(arg0: AnyRef): Boolean

    Equivalent to `!(this eq that)`.

    Equivalent to `!(this eq that)`.

    returns

      `true` if the argument is not a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

19. #### final def notify(): Unit

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

20. #### final def notifyAll(): Unit

    Wakes up all threads that are waiting on the receiver object's monitor.

    Wakes up all threads that are waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

21. #### def shouldFlip(sym: Global.Symbol, tvar: Global.Symbol): Boolean

    Definition Classes
      VarianceValidator

22. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

23. #### def toString(): String

    Creates a String representation of this object.

    Creates a String representation of this object. The default representation is platform dependent. On the java platform it is the concatenation of the class name, "@", and the object's hashcode in hexadecimal.

    returns

      a String representation of the object.

    Definition Classes
      AnyRef → Any

24. #### def traverse(tree: Global.Tree): Unit

    Definition Classes
      VarianceValidator → Traverser

25. #### def traverseAnnotations(annots: List[Global.Tree]): Unit

    Definition Classes
      Traverser

26. #### def traverseCases(cases: List[Global.CaseDef]): Unit

    Definition Classes
      Traverser

27. #### def traverseConstant(c: Global.Constant): Unit

    Definition Classes
      Traverser

28. #### def traverseGuard(guard: Global.Tree): Unit

    Definition Classes
      Traverser

29. #### def traverseImportSelector(sel: Global.ImportSelector): Unit

    Definition Classes
      Traverser

30. #### def traverseModifiers(mods: Global.Modifiers): Unit

    Definition Classes
      Traverser

31. #### def traverseName(name: Global.Name): Unit

    Definition Classes
      Traverser

32. #### def traverseParams(params: List[Global.Tree]): Unit

    Definition Classes
      Traverser

33. #### def traverseParamss(vparamss: List[List[Global.Tree]]): Unit

    Definition Classes
      Traverser

34. #### def traverseParents(parents: List[Global.Tree]): Unit

    Definition Classes
      Traverser

35. #### def traversePattern(pat: Global.Tree): Unit

    Definition Classes
      Traverser

36. #### def traverseSelfType(self: Global.ValDef): Unit

    Definition Classes
      Traverser

37. #### def traverseStats(stats: List[Global.Tree], exprOwner: Global.Symbol): Unit

    Definition Classes
      Traverser

38. #### def traverseTrees(trees: List[Global.Tree]): Unit

    Definition Classes
      Traverser

39. #### def traverseTreess(treess: List[List[Global.Tree]]): Unit

    Definition Classes
      Traverser

40. #### def traverseTypeArgs(args: List[Global.Tree]): Unit

    Definition Classes
      Traverser

41. #### def traverseTypeAscription(tpt: Global.Tree): Unit

    Definition Classes
      Traverser

42. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

43. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

44. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

### Inherited from Global.VarianceValidator

### Inherited from Global.Traverser

### Inherited from AnyRef

### Inherited from Any

### Ungrouped